
export default function arr2Tree(arr = [], parent = 'parentId', key = 'key') {
  // 转换为字典
  const dict = arr.reduce((acc, item) => {
    return {
      ...acc,
      [item[key]]: {
        ...item,
        children: []
      }
    }
  }, {});

  // 挂载父子节点
  const rootId = -1;
  const tree = [];
  for (let item of arr) {
    const parentNodeId = item[parent];

    if (parentNodeId === rootId) {
      tree.push(dict[item[key]]);
    } else {
      const parentNode = dict[parentNodeId];
      if (parentNode) {
        parentNode.children.push(item);
      }
    }
  }

  console.log(tree, dict)

  return [tree, dict];
}

